package ut.maxorato.bsc.crawler.diff;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import ut.maxorato.bsc.crawler.model.RequestContext;

public class RemovedNameComparisonStrategy extends PageComparisonStrategy {
    private static final Logger log = LoggerFactory.getLogger(RemovedNameComparisonStrategy.class);

    public RemovedNameComparisonStrategy(RequestContext requestContext, String originalUrl) {
        super(requestContext, originalUrl);
    }

    public boolean isValidAlternateUrl(String alternateUrl) {
        ComparisonContext context = new ComparisonContext(alternateUrl);

        Boolean initialResult = responseCodeBasedComparison(context);
        if (initialResult != null) {
            return initialResult;
        }

        DomDelta originalVsAlternate = domDeltaCalculator.calculate(originalResult.text, context.alternateResult.text);
        originalVsAlternate = filterEffectiveDelta(originalVsAlternate);

        if (originalVsAlternate.differences.size() == 0) {
            return true;
        }

        return false;
    }
}
